;MASM/TASM Win32 coding tutorial pt. 3.141  -  by T$ (ts@deinmeister.de)
;
;compile with:
; TASMX.EXE /s /r /ml /m4 win004.asm    (TASM)
; ML.EXE /Dmasm /c /Cx /coff win004.asm (MASM)
;link with:
; TLINK32.EXE -c -Tpe -aa win004,,,import32.lib,,win004.res (TASM)
; LINK.EXE win004 kernel32.lib user32.lib winmm.lib win004.res /subsystem:windows (MASM)

;Everything written in part 2.718 won`t be repeated here - if something is still curious,
;a look into the first three parts may help

		.586
		.model flat, stdcall

	IFDEF masm
		option casemap :none
	ENDIF

include windows.inc
	IFNDEF masm
          include mmsystem.inc 
;contains some Multimedia constants and definitions. Not needed with MASM,
;since the MASM include file already contains most common includes
	ENDIF
include ddraw.inc

	IFNDEF masm
		WS_EX_DLGMODALFRAME                  equ 1h
		WS_EX_NOPARENTNOTIFY                 equ 4h
		WS_EX_TOPMOST                        equ 8h
		WS_EX_ACCEPTFILES                    equ 10h
		WS_EX_TRANSPARENT                    equ 20h
		WS_EX_MDICHILD                       equ 00000040h
		WS_EX_TOOLWINDOW                     equ 00000080h
		WS_EX_WINDOWEDGE                     equ 00000100h
		WS_EX_CLIENTEDGE                     equ 00000200h
		WS_EX_CONTEXTHELP                    equ 00000400h
		WS_EX_RIGHT                          equ 00001000h
		WS_EX_LEFT                           equ 00000000h
		WS_EX_RTLREADING                     equ 00002000h
		WS_EX_LTRREADING                     equ 00000000h
		WS_EX_LEFTSCROLLBAR                  equ 00004000h
		WS_EX_RIGHTSCROLLBAR                 equ 00000000h
		WS_EX_CONTROLPARENT                  equ 00010000h
		WS_EX_STATICEDGE                     equ 00020000h
		WS_EX_APPWINDOW                      equ 00040000h
		WS_EX_OVERLAPPEDWINDOW               equ WS_EX_WINDOWEDGE OR WS_EX_CLIENTEDGE
		WS_EX_PALETTEWINDOW                  equ WS_EX_WINDOWEDGE OR WS_EX_TOOLWINDOW OR WS_EX_TOPMOST

	     WNDCLASSEX struc
        	cbSize       dd      ?
	        Style        dd      ?       ; class style
		lpfnWndProc  dd      ?
        	cbClsExtra   dd      ?
        	cbWndExtra   dd      ?
	        hInstance    dd      ?       ; instance handle
	        hIcon        dd      ?       ; class icon handle
	        hCursor      dd      ?       ; class cursor handle
	        hbrBackground dd     ?       ; class background brush
	        lpszMenuName dd      ?       ; menu name
	        lpszClassName dd     ?       ; far ptr to class name
	        hIconSm       dd     ?
	     WNDCLASSEX ends
	ENDIF

	IFDEF masm
		SendMessageA equ SendMessageA@16
		ExitProcess equ ExitProcess@4
		GetModuleHandleA equ GetModuleHandleA@4
		RegisterClassExA equ RegisterClassExA@4
		LoadIconA equ LoadIconA@8
		LoadCursorA equ LoadCursorA@8
		CreateWindowExA equ CreateWindowExA@48
		GetMessageA equ GetMessageA@16
		DispatchMessageA equ DispatchMessageA@4
		DefWindowProcA equ DefWindowProcA@16
		PostQuitMessage equ PostQuitMessage@4
		MessageBoxA equ MessageBoxA@16
		timeGetTime equ timeGetTime@0
		LocalAlloc equ LocalAlloc@8
		LocalFree equ LocalFree@4
		CreateFileA equ CreateFileA@28
		ReadFile equ ReadFile@20
		CloseHandle equ CloseHandle@4
		CreateThread equ CreateThread@24
		GetExitCodeThread equ GetExitCodeThread@8
		SuspendThread equ SuspendThread@4
		ResumeThread equ ResumeThread@4
		SetThreadPriority equ SetThreadPriority@8
		timeBeginPeriod equ timeBeginPeriod@4
		timeSetEvent equ timeSetEvent@20
		timeEndPeriod equ timeEndPeriod@4
		timeKillEvent equ timeKillEvent@4
	ENDIF

		extrn GetModuleHandleA:near
		extrn RegisterClassExA:near
		extrn LoadIconA:near
		extrn LoadCursorA:near
		extrn CreateWindowExA:near
		extrn GetMessageA:near
		extrn DispatchMessageA:near
		extrn ExitProcess:near
		extrn DefWindowProcA:near
		extrn PostQuitMessage:near
		extrn MessageBoxA:near
		extrn SendMessageA:near

		extrn timeGetTime:near
		extrn LocalAlloc:near
		extrn LocalFree:near
		extrn CreateFileA:near
		extrn ReadFile:near
		extrn CloseHandle:near
		
		extrn CreateThread:near
		extrn GetExitCodeThread:near
		extrn SuspendThread:near
		extrn ResumeThread:near
		extrn SetThreadPriority:near
		
		extrn timeBeginPeriod:near
		extrn timeSetEvent:near
		extrn timeEndPeriod:near
		extrn timeKillEvent:near
		
		.data

;Definition of the window class:

		OurWindowclass WNDCLASSEX <size WNDCLASSEX,CS_VREDRAW or CS_HREDRAW,Windowprocedure,0,0,0,0,0,COLOR_HIGHLIGHT,0,Windowclassname,0>

		Windowhandle dd 0

;the following constants describe the content of the message structure residing on the stack:
		MSGhWnd   equ 0
		MSGmsg    equ 4
		MSGwParam equ 8
		MSGlParam equ 12

;GetMessage requires a buffer for an incoming Message (one Message = 7 DWORDS):
		MessageBuffer dd 0,0,0,0,0,0,0

		Windowclassname db "OurWindowclass",0
		Windowname db "Multithreaded synching demo",0

;Name of Ressources:
		Picturename db "Nuke",0
		Cursorname db "Fisch",0

;these constants are stand for themselves - change them, if you want ;-)
		WindowsizeInX equ 300
		WindowsizeInY equ 200
		WindowpositionInX equ 100
		WindowpositionInY equ 120



		.code

		_warp999mrsulu:


		push 0
		call GetModuleHandleA
		mov [OurWindowclass.hInstance],eax

		push offset Picturename
		push [OurWindowclass.hInstance]
		call LoadIconA
		mov [OurWindowclass.hIcon],eax
		push offset Cursorname
		push [OurWindowclass.hInstance]
		call LoadCursorA
		mov [OurWindowclass.hCursor],eax

		push offset OurWindowclass
		call RegisterClassExA

		push 0
		push [OurWindowclass.hInstance]
		push 0
		push 0
		push WindowsizeInY
		push WindowsizeInX
		push WindowpositionInY
		push WindowpositionInX
	       IFNDEF masm
		push (WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX) * 65536
	       ENDIF
	       IFDEF masm
		push WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
	       ENDIF
		push offset Windowname
		push offset Windowclassname
		push WS_EX_WINDOWEDGE + WS_EX_CLIENTEDGE 
		call CreateWindowExA
		mov Windowhandle,eax

;do startup init crap
include startup.inc

;The most important place in a windows program: The Message Pump / Message Loop. 

		MessagePumpStart:

		push 0
		push 0
		push 0
		push offset MessageBuffer
		call GetMessageA
		or eax,eax
		jz WM_QUIT_received
		push offset MessageBuffer
		call DispatchMessageA
		jmp MessagePumpStart


		WM_QUIT_received:
		push 0
		call ExitProcess

;------------
;the window procedure
		Windowprocedure:

;check interesting messages here
		include msgproc.inc

		cmp dword ptr [esp+4+MSGmsg],WM_DESTROY
		je Selfdestruction
		jmp DefWindowProcA

		Selfdestruction:
; process cleanup shit here
		include cleanup.inc
		push 0
		call PostQuitMessage
		xor eax,eax
		ret 16

;the thread code and other stuff is placed here

include rdfile.inc

include thrd1.inc
include thrd2.inc
include thrd34.inc

		end _warp999mrsulu
